if not srb2p return end

-- Define our base character's stats!
charStats["milne"] = {

		-- GENERAL

		name = "Milne",		-- This is only for bots / enemies
		basehp = 68,			-- base HP for level 1 (Cannot be <= 0)
		basesp = 20,			-- base SP for level 1 (Can be 0, but not < 0!)
		persona = "penthesilea",
		persona_pvp = "penthesilea_pvp",
		melee_natk = "milne_1",	-- normal melee attack

		atk = 45,	   
		acc = 80,	  
		crit = 4,	   

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame, ["SPR2_CONST"]}
		-- (SPR2 must be a string, and is optional. Only for use with SPR_PLAY)

		-- Note: As of Beta 1.0.0, not all animations are implemented
		-- (* = unimplemented)

	    anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},		-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},		-- standing (low HP)
		anim_stand_bored =	{SPR_PLAY, A, B, A, B, A, B, A, B, 10, "SPR2_WAIT"},	-- standing (rare anim)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_WALK"},		-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, E, F, G, H, 2, "SPR2_WALK"},		-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, D, E, F, G, H, 1, "SPR2_SPIN"},	-- attacking
		anim_aoa_end =		{SPR_PLAY, A, B, C, D, E, F, G, H, 1, "SPR2_SPIN"},	-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},		-- taking damage
		anim_getdown =		{SPR_PLAY, A, 1, "SPR2_PAIN"},		-- knocked down from weakness / crit
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_PAIN"},		-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_JUMP"},		-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_PAIN"},		-- dies
		anim_revive =		{SPR_PLAY, A, 1, "SPR2_JUMP"},		-- gets revived
		
		anim_special1 =		{SPR_PLAY, A, 2, "SPR2_SPNG"},	-- charge
		anim_special2 = {SPR_PLAY, A, 2, "SPR2_CLMB"}, -- crystal lance start
		anim_special3 = {SPR_PLAY, A, 2, "SPR2_GLID"}, -- crystal lance go		

		
		-- VOICES
		-- Possible list of voices
		-- vfx_action = {"sfx_voice1", "sfx_voice2", [...], "sfx_voicen"}

		vfx_summon = {},	-- Summoning Persona to use a Skill
        vfx_skill = {},		-- Used a Skill
        vfx_item = {},		-- Used an item
        vfx_hurt = {"sfx_pml7"},		-- Sustained damage
        vfx_hurtx = {"sfx_pml5","sfx_pml7"},		-- Sustained heavy damage / Critical hit / Weakness
        vfx_die = {"sfx_pml7"},		-- Death
        vfx_heal = {"sfx_pml6"},		-- Healed by teammate
        vfx_healself = {"sfx_pml6"},	-- Healed self
        vfx_kill = {"sfx_pml1","sfx_pml2"},		-- Killed an enemy
        vfx_1more = {},		-- Performed 1more
        vfx_crit = {},		-- Cut-in for Weakness/Critical Hit
        vfx_aoaask = {"sfx_pml4"},	-- Ask to All-Out Attack
        vfx_aoado = {},		-- Performing All-Out Attack
        vfx_aoarelent = {"sfx_pml6"},	-- Relenting from All-Out Attack
        vfx_miss = {"sfx_pml5","sfx_pml6"},		-- Missed attack
        vfx_dodge = {"sfx_pml2"},		-- Dodged enemy attack
        vfx_win = {"sfx_pml1","sfx_pml2","sfx_pml3"},		-- Battle won
        vfx_levelup = {"sfx_pml3"},	-- Level Up!

		icon = "ICO_MILN",			-- head icon for character select
		hudbust = "H_MLNBAR",			-- patch to draw on the stat hud
		hudbustlayer = "",
		hudaoa = "H_MLNAOA",		-- patch for all out attack hud
		aoa_quote = "May I have \nthis dance?",
		hudcutin = "MILN_A",		-- cut in frames prefix

		-- Tip to display on the character select.
		-- Give insight on their skill type and their strengths/weaknesses in battle!
		tip = "Milne can learn powerful Ice attacks \nand utility spells.\nShe's mainly weak \nto fire and strike attacks.\nShe can easily become the best\nmagic damage dealer",
}

attackDefs["milne_1"] = {
		name = "Crystal Lance",
		type = ATK_PIERCE,
		power = 40,
		accuracy = 999,
		costtype = CST_HPPERCENT,
		technical = COND_FREEZE,
		cost = 4,
		critical = 5,
		physical = true,	-- Checking this uses the character atk/acc/crit stat instead of the attack's
		anim_norepel = true,	-- do not bounce back our ANIMATION
		desc = "Regular attack using the \npierce attribute.",
		target = TGT_ENEMY,
		anim = 	function(mo, targets, hittargets, timer)
			local target = targets[1]
			local atarget = hittargets[1]
			local cam = server.P_BattleStatus[mo.battlen].cam
			if timer == 1
				ANIM_set(mo, mo.anim_special2, true)
				mo.reachedtarget = 0	-- yeah we can use variables here that you like it or not :^)
				mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
				playSound(mo.battlen, sfx_mllnc1)

				local cx = mo.x + 128*cos(mo.angle - ANG1*25)
				local cy = mo.y + 128*sin(mo.angle - ANG1*25)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				
				-- now make it zoom out a little
				CAM_goto(cam, cam.x-24*cos(cam.angle), cam.y-24*sin(cam.angle), cam.z+FRACUNIT*5, 1*FRACUNIT)
				
				local time = TICRATE/4*3/2
				local i = 0 while i < 16
					local explode = P_SpawnMobjFromMobj(mo,
					P_ReturnThrustX(nil, mo.angle, -4*skins[mo.skin].radius),
					P_ReturnThrustY(nil, mo.angle, -4*skins[mo.skin].radius),
					skins[mo.skin].height/2,MT_SHATTERCRYSTAL)
					if explode and explode.valid
						explode.flags = $|MF_NOGRAVITY
						explode.scale = mo.destscale*3/2
						explode.fuse = time
						explode.angle = (ANGLE_22h*i)+ANGLE_180
						explode.rollangle = FixedAngle(P_RandomKey(360)*FRACUNIT)
						explode.threshold = P_RandomKey(2)
						P_InstaThrust(explode,explode.angle,16*FRACUNIT)
						explode.momz = explode.momx+(P_GetMobjGravity(explode)*-4)
						P_InstaThrust(explode, mo.angle+ANGLE_90,explode.momy)
						
						//The unique stuff
						P_TeleportMove(explode, explode.x+explode.momx*time,
						explode.y+explode.momy*time, explode.z+explode.momz*time)
						explode.momx = $*-1
						explode.momy = $*-1
						explode.momz = $*-1
					end
					i = $+1
				end
			end

			if timer < TICRATE/4
				P_InstaThrust(mo, mo.angle, -16*mo.scale)
			else
				if timer == TICRATE/4
					ANIM_set(mo, mo.anim_special3, true)
					playSound(mo.battlen, sfx_mllnc2)
				end
				if timer == TICRATE*2/5
					local cx = target.x + 256*cos(target.angle + ANG1*20)
					local cy = target.y + 256*sin(target.angle + ANG1*20)
					P_TeleportMove(cam, cx, cy, target.z + FRACUNIT*30)
					cam.angle = R_PointToAngle2(cx, cy, target.x, target.y)
					-- now make it zoom out a little
					CAM_stop(cam)
				end
				if not mo.reachedtarget
					P_InstaThrust(mo, mo.angle, 50*mo.scale)
					if leveltime%2
						P_SpawnGhostMobj(mo)
					end
				end

				if (R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*100
				or FixedHypot(mo.momx, mo.momy) < FRACUNIT*10) and not mo.reachedtarget
					mo.reachedtarget = $+1

					playSound(mo.battlen, sfx_phys)
					for i = 1, 2
						createSplat(mo)
					end
					damageObject(atarget)

					-- spawn slash and blood
					createSplat(mo)
					local shot = P_SpawnMobj(target.x + P_RandomRange(-15, 15)*FRACUNIT, target.y + P_RandomRange(-15, 15)*FRACUNIT, target.z + P_RandomRange(16, 48)*FRACUNIT, MT_DUMMY)
					playSound(mo.battlen, sfx_rail1)
					shot.state = S_SHOT1
					shot.scale = $ + P_RandomRange(0, 65535)*3
					shot.colorized = true
					shot.color = SKINCOLOR_SUPERPURPLE1
					P_StartQuake(FRACUNIT*10, 5)
				elseif mo.reachedtarget == 1 and timer > TICRATE/2+TICRATE/4
					ANIM_set(mo, mo.anim_getup, true)
					P_SetObjectMomZ(mo, 8*FRACUNIT, false)
					P_InstaThrust(mo, mo.angle, -16*mo.scale)
					playSound(mo.battlen, sfx_jump)
					mo.reachedtarget = $+1
				elseif mo.reachedtarget > 1 and P_IsObjectOnGround(mo)
					return true
				end
			end
		end,
}