//Initalize the variables
for player in players.iterate
	player.milnekick = 0
	player.milnecarry = nil
	player.milnespringtime = 0
	player.crystallance = 0
	player.milnedeadtimer = 0
	player.milneairtime = 0
	player.milnehugpain = 0
end

//Player States
freeslot("S_MILNE_KICK")
freeslot("SPR2_FKIK")
states[S_MILNE_KICK] = {SPR_PLAY, SPR2_FKIK, 3, nil, 0, 0, S_MILNE_KICK}

//Kirby junk
if not kirbyabilitytable
    rawset(_G, "kirbyabilitytable", {})
end

kirbyabilitytable[MT_THROWNCRYSTAL] = 6
kirbyabilitytable["milne"] = 3

//Dumb constants
local LANCETIME = TICRATE/2
local LANCECHARGETIME = TICRATE/6
local GRAVITYMUL = 128
local GRAVITYDIV = 106

//milnegrief command
local milneable = true
local stronk = false
addHook("NetVars", function(network)
	milneable = network($)
	stronk = network($)
end)

COM_AddCommand("milnegrief", function(player, arg)
	if arg
		if arg == "0" or arg == "false" or arg == "off"
			milneable = false
			CONS_Printf(player, "Milne can no longer pick up pushables, springs, and other players.")
		elseif arg == "1" or arg == "default" or arg == "true" or arg == "on"
			milneable = true
			CONS_Printf(player, "Milne can now hit pick up pushables, springs, and other players.")
		elseif milneable
			CONS_Printf(player, "milnegrief [on/off] - When on, Milne players can pick up pushables, springs, and other players in addition to enemies. Currently on, which is the default.")
		else
			CONS_Printf(player, "milnegrief [on/off] - When on, Milne players can pick up pushables, springs, and other players in addition to enemies. Currently off, which is no fun.")
		end
	elseif milneable
		CONS_Printf(player, "milnegrief [on/off] - When on, Milne players can pick up pushables, springs, and other players in addition to enemies. Currently on, which is the default.")
	else
		CONS_Printf(player, "milnegrief [on/off] - When on, Milne players can pick up pushables, springs, and other players in addition to enemies. Currently off, which is no fun.")
	end
end, 1)

COM_AddCommand("stronk", function(player, arg)
	stronk = not stronk
end, 1)

//Dumb stuff for the Crystal Lance
addHook("PreThinkFrame", do
	for player in players.iterate
		if player.milnekick
			if player.powers[pw_super] and player.cmd.buttons&BT_JUMP
				player.cmd.buttons = ($&BT_CUSTOM3)|BT_JUMP
			else
				player.cmd.buttons = $&BT_CUSTOM3
			end
		end
		if not (player.mo and player.mo.valid and player.mo.skin == "milne")
		continue end
		if (player.crystallance > 0 or player.climbing)
			if player.climbing == 1
				player.cmd.forwardmove = 0
				player.cmd.sidemove = 0
			else
				player.cmd.forwardmove = 50
				player.cmd.sidemove = 0
			end
		end
	end
end)
addHook("JumpSpecial", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "milne")  return end
	if player.climbing
		if not (player.pflags & PF_JUMPDOWN)
			player.climbing = 0
			P_DoJump(player,true)
		end 
		return true
	end
end)

//Function for resetting/throwing objects Milne is carrying
local DropMilneCarry = function(player, throwing)
	if not player.mo and player.mo.valid
		print("A Milne-carried object has failed to drop properly because the player carrying the object doesn't exist!")
	end
	
	if player.milneprevflags == nil
		player.milneprevflags = player.milnecarry.info.flags
	end
	
	if player.milneprevflags&MF_SPRING
		player.milnecarry.flags = player.milneprevflags&~MF_NOGRAVITY
		player.milnecarry.milnethrown = 1
		player.milnecarry.milnerespawn = -2
		player.milnecarry.fuse = TICRATE*9
		//if not P_IsObjectOnGround(player.mo) and throwing
		//	P_DoSpring(player.milnecarry, player.mo)
		//	player.mo.state = S_PLAY_SPRING
		//end
	elseif player.milneprevflags&MF_BOSS
		player.milnecarry.flags = player.milneprevflags
		P_KillMobj(player.milnecarry)
		player.milnecarry.flags = $&~MF_NOCLIP|MF_SLIDEME
		if player.milnecarry.type == MT_CYBRAKDEMON
			player.milnecarry.tics = -1
			player.milnecarry.flags = $&~MF_NOGRAVITY&~MF_NOCLIPHEIGHT
			S_StartSound(nil, sfx_bedie2)
		elseif player.milnecarry.type == MT_EGGMOBILE2
			player.milnecarry.state = S_EGGMOBILE2_DIE1
		end
	elseif player.milneprevflags&MF_ENEMY or player.milnecarry.type == MT_TNTBARREL
	or player.milneprevflags&MF_MONITOR
		if player.milnecarry.metaldeath == MT_METALSONIC_RACE
			for player in players.iterate
				player.pflags = $|PF_FINISHED
			end
		end
		player.milnecarry.target = player.mo
		player.milnecarry.flags = MF_MISSILE
		player.milnecarry.milnethrown = 1
	else
		player.milnecarry.flags = player.milneprevflags&~MF_NOGRAVITY
		if player.milnecarry.info.flags&MF_PUSHABLE
			player.milnecarry.flags = $|MF_PUSHABLE
		end
		if player.milnecarry.player
			P_ResetPlayer(player.milnecarry.player)
			if not throwing
				player.milnecarry.state = S_PLAY_FALL
			elseif gametyperules&GTR_FRIENDLY or
			(G_GametypeHasTeams() and player.milnecarry.player.ctfteam == player.ctfteam)
				player.milnecarry.state = S_PLAY_ROLL
				player.milnecarry.player.pflags = $|PF_SPINNING
			else
				player.milnecarry.state = S_PLAY_PAIN
			end
		elseif player.milnecarry.type == MT_MINUS
			player.milnecarry.state = player.milnecarry.info.missilestate
		else
			player.milnecarry.state = player.milnecarry.info.spawnstate
		end
		if player.milnecarry.battleobject
			player.milnecarry.target = player.mo
		end
	end
		
	if throwing
		player.milnecarry.flags = $|MF_NOCLIPTHING
		
		local speed = 40
		if P_GetPlayerControlDirection(player) == 0
		or (abs(player.cmd.forwardmove) < 35 and abs(player.cmd.sidemove) < 35)
			speed = 10
		end
		
		//Aim your throw
		//You can only aim players at objects if they're on your team
		//Pushables and bots can't be aimed at monitors
		local lockon = P_LookForEnemies(player, false,
		not(player.milnecarry.flags&MF_PUSHABLE or player.milnecarry.flags&MF_SPRING
		or (player.milnecarry.player and player.milnecarry.player.bot)))
		
		if lockon and lockon.valid and (player.milnecarry.flags&MF_MISSILE
		or player.milnecarry.flags&MF_PUSHABLE or player.milnecarry.flags&MF_SPRING
		or (player.milnecarry.player and (gametyperules&GTR_FRIENDLY or
		(G_GametypeHasTeams() and player.milnecarry.player.ctfteam == player.ctfteam))))
			speed = 60
			player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, lockon.x, lockon.y)
			player.drawangle = player.mo.angle
			local zthing = player.milnecarry.z
			if player.mo.eflags & MFE_VERTICALFLIP
				zthing = $+player.milnecarry.height
			end
			if lockon.eflags & MFE_VERTICALFLIP
				zthing = lockon.z - $
			else
				zthing = (lockon.z+lockon.height) - $
			end
			zthing = $-lockon.height/4*P_MobjFlip(lockon)
			player.milnecarry.momz = zthing / max(P_AproxDistance(lockon.x - player.mo.x, lockon.y - player.mo.y)/max(speed*player.mo.scale, player.speed*2),1)
			if not (player.mo.eflags&MFE_UNDERWATER)
				P_SetObjectMomZ(player.milnecarry, FRACUNIT, true)
			end
		elseif player.aiming*P_MobjFlip(player.mo) > 0
			P_SetObjectMomZ(player.milnecarry, min(AngleFixed(player.aiming), 20*FRACUNIT), false)
		else
			P_SetObjectMomZ(player.milnecarry, 0, false)
		end
		
		P_InstaThrust(player.milnecarry, player.mo.angle, max(speed*player.mo.scale, player.speed*2))
		
		P_TryMove(player.milnecarry, player.milnecarry.x+player.milnecarry.momx,
		player.milnecarry.y+player.milnecarry.momy, true)
		player.milnecarry.z = $+player.milnecarry.momz
		
		player.milnecarry.flags = $&~MF_NOCLIPTHING
	elseif not P_PlayerInPain(player) and player.powers[pw_super] != 1
		player.mo.state = S_PLAY_WALK
	end
		
	player.milneprevflags = nil
	player.milnecarry = nil
end

local startcrystallance = function(player)
	S_StopSoundByID(player.mo, sfx_crythr)
	S_StartSound(player.mo, sfx_mllnc1)
	player.crystallance = LANCETIME+LANCECHARGETIME
	player.mo.angle = player.mo.angle
	player.drawangle = player.mo.angle
	player.pflags = $&~PF_STARTJUMP
	player.milnespringtime = 0
	
	local time = LANCECHARGETIME*3/2
	local i = 0 while i < 16
		local explode = P_SpawnMobjFromMobj(player.mo,
		P_ReturnThrustX(nil, player.mo.angle, -4*skins[player.mo.skin].radius),
		P_ReturnThrustY(nil, player.mo.angle, -4*skins[player.mo.skin].radius),
		player.height/2,MT_SHATTERCRYSTAL)
		if explode and explode.valid
			explode.flags = $|MF_NOGRAVITY
			explode.scale = player.mo.destscale*3/2
			explode.fuse = time
			explode.angle = (ANGLE_22h*i)+ANGLE_180
			explode.rollangle = FixedAngle(P_RandomKey(360)*FRACUNIT)
			explode.threshold = P_RandomKey(2)
			P_InstaThrust(explode,explode.angle,16*FRACUNIT)
			explode.momz = explode.momx+(P_GetMobjGravity(explode)*-4)
			P_InstaThrust(explode, player.mo.angle+ANGLE_90,explode.momy)
			
			//The unique stuff
			P_TeleportMove(explode, explode.x+explode.momx*time,
			explode.y+explode.momy*time, explode.z+explode.momz*time)
			explode.momx = $*-1
			explode.momy = $*-1
			explode.momz = $*-1
		end
		i = $+1
	end
end

local bouncethrown = function(mobj, bounce, spike)
	if not mobj.milnethrown return end
	if mobj.milnethrown > 1
		mobj.momz = abs($)*P_MobjFlip(mobj)
	else
		mobj.momz = abs($/2)*P_MobjFlip(mobj)
		mobj.momx = $/4
		mobj.momy = $/4
	end
	mobj.milnethrown = $+1
	if bounce then P_BounceMove(mobj) end
	S_StartSound(mobj, sfx_s3k9e)
	if not spike then S_StartSound(mobj, sfx_cdfm64) end
	if not (mobj.flags&MF_MISSILE) return end
	if mobj.type == MT_TNTBARREL
		P_KillMobj(mobj)
		return
	end
	mobj.flags = $|MF_BOUNCE&~MF_SLIDEME
	mobj.rollangle = ANGLE_180
end

function A_MonitorPop(actor, var1, var2)
    super(actor, var1, var2)
	if actor.milnethrown
		actor.rollangle = 0
		actor.fuse = 0
		if actor.info.deathstate == S_REDBOX_POP1
			actor.state = S_REDBOX_POP2
		elseif actor.info.deathstate == S_BLUEBOX_POP1
			actor.state = S_BLUEBOX_POP2
		else
			actor.state = S_BOX_POP2
		end
		if gametype != GT_COOP and multiplayer
			actor.tics = TICRATE*5
			if CV_FindVar("respawnitem").value
				actor.tics = CV_FindVar("respawnitemtime").value*TICRATE + 2
			end
		end
		actor.flags = $&~MF_NOCLIPHEIGHT&~MF_NOGRAVITY
	end
end

//If a player leaves, make sure they drop whatever they were carrying first!
addHook("PlayerQuit", function(player)
	if player.milnecarry and player.milnecarry.valid
		DropMilneCarry(player, false)
	end
end)

//Spawn an afterimage for the crystal, and shatter it when it breaks
//With MF2_BOSSNOTRAP, it slows down until it breaks
addHook("MobjThinker", function(mobj)
	if mobj.state == S_THROWNCRYSTAL and mobj.fuse != TICRATE*3
		P_SpawnGhostMobj(mobj)
		if mobj.flags2&MF2_BOSSNOTRAP
			mobj.momx = FixedMul($, FRACUNIT*92/100)
			mobj.momy = FixedMul($, FRACUNIT*92/100)
			mobj.momz = FixedMul($, FRACUNIT*92/100)
			
			if mobj.target and mobj.target.valid and mobj.target.skin == "milne"
			and mobj.target.player and mobj.target.player.crystallance > 0
				P_RemoveMobj(mobj)
				return
			elseif (abs(mobj.momx) < mobj.scale*4 and abs(mobj.momy) < mobj.scale*4
			and abs(mobj.momz) < mobj.scale*4)
				S_StartSound(mobj, sfx_shattr)
				P_KillMobj(mobj)
				mobj.momx = 0
				mobj.momy = 0
				mobj.momz = 0
			end
		end
	elseif not mobj.threshold and mobj.state == S_SMOKE1
		local i = 0 while i < 4
			local explode = P_SpawnMobjFromMobj(mobj,0,0,0,MT_SHATTERCRYSTAL)
			if explode and explode.valid
				explode.scale = mobj.scale/2
				explode.threshold = P_RandomKey(2)
				P_InstaThrust(explode, mobj.angle+ANGLE_180+ANGLE_45-((ANGLE_22h)*i), 5*mobj.scale)
				P_SetObjectMomZ(explode, 10*FRACUNIT, false)
				explode.fuse = TICRATE*3
			end
			i = $+1
		end
		mobj.threshold = 1
	end
end, MT_THROWNCRYSTAL)

//Crystal hit sound
addHook("MobjDamage", function(target, inflictor)
	if inflictor and inflictor.valid and inflictor.type == MT_THROWNCRYSTAL
		S_StartSound(inflictor, sfx_mlshtr)
	end
end)

//Spin the crystal debris
addHook("MobjThinker", function(mobj)
	if mobj.threshold
		mobj.rollangle = $-ANGLE_22h
	else
		mobj.rollangle = $+ANGLE_22h
	end
end, MT_SHATTERCRYSTAL)

//Stupidity
addHook("MobjThinker", function(mobj)
	if mobj.state != S_THROWNCRYSTAL return end
	if mobj.threshold
		mobj.rollangle = $-ANGLE_22h
	else
		mobj.rollangle = $+ANGLE_22h
	end
end, MT_SONIC3KBOSSEXPLODE)

//Milne's core
addHook("MobjThinker", function(mobj)
	if not mobj.threshold
		S_StartSoundAtVolume(mobj, sfx_mlcore, 128)
		mobj.scalespeed = mobj.scale/6
		P_SetObjectMomZ(mobj, 4*FRACUNIT, false)
		mobj.scale = $/4
		mobj.fuse = TICRATE*10
		mobj.sprite = SPR_MLCR
		mobj.frame = 1|TR_TRANS10
		mobj.threshold = 1
	end
	if not (mobj.fuse%2)
		local ghost = P_SpawnGhostMobj(mobj)
		ghost.scale = mobj.scale/4
		ghost.flags = $&~MF_NOGRAVITY
		if mobj.flags2&MF2_OBJECTFLIP
			ghost.flags2 = $|MF2_OBJECTFLIP
			ghost.z = $+mobj.scale*36
		end
		P_TryMove(ghost,
		ghost.x+FixedMul(P_SignedRandom()*P_RandomFixed(), mobj.scalespeed*2/3),
		ghost.y+FixedMul(P_SignedRandom()*P_RandomFixed(), mobj.scalespeed*2/3),
		true)
		P_InstaThrust(mobj, FixedAngle(360*P_RandomFixed()),
		FixedMul(P_SignedRandom()*P_RandomFixed(), mobj.scalespeed/9))
	end
	if mobj.scale <= mobj.scalespeed*6
		mobj.destscale = mobj.scalespeed*9
	elseif mobj.scale >= mobj.scalespeed*9
		mobj.destscale = mobj.scalespeed*6
	end
end, MT_MILNE_CORE)

addHook("MobjFuse", function(mobj)
	P_SpawnGhostMobj(mobj)
end, MT_MILNE_CORE)

//Code to disable Milne from stealing your friend's air bubbles
addHook("TouchSpecial", function(special, toucher)
  if not (special and special.valid and toucher and toucher.valid and toucher.player) return end
	if toucher.skin == "milne" then
		return true
	end
end, MT_EXTRALARGEBUBBLE)

//Allow other players to join your dance
addHook("MobjCollide", function(thing, tmthing)
	if thing and thing.valid and thing.player
	and tmthing and tmthing.valid and tmthing.player and tmthing.player.milnekick
		thing.milnejoin = tmthing
	end
end, MT_PLAYER)

local noringsteal = function(special, toucher)
	if toucher and toucher.valid and toucher.player and toucher.skin == "milne"
	and toucher.player.milnehugpain
		return true
	end
end

addHook("TouchSpecial", noringsteal, MT_FLINGRING)
addHook("TouchSpecial", noringsteal, MT_FLINGBLUESPHERE)
addHook("TouchSpecial", noringsteal, MT_FLINGEMERALD)
addHook("TouchSpecial", noringsteal, MT_FLINGCOIN)
addHook("TouchSpecial", noringsteal, MT_FLINGNIGHTSCHIP)

//Reset the variables on spawn
addHook("PlayerSpawn", function(player)
	player.milnekick = 0
	player.milnecarry = nil
	player.milnespringtime = 0
	player.crystallance = 0
	player.milnedeadtimer = 0
	player.milneairtime = 0
	player.milnehugpain = 0
end)

//
//Main Thinker
//
addHook("PlayerThink", function(player)
	//Detect when we press Custom 3
	if not (player.cmd.buttons & BT_CUSTOM3)
		player.milne3tapready = true
		player.milne3tapping = false
	elseif player.milne3tapready then
		player.milne3tapping = true
		player.milne3tapready = false
	else
		player.milne3tapping = false
	end
	
	//Team Fortress 2!!
	//Epic
	if not (player.mo and player.mo.valid and player.mo.health)
	or P_PlayerInPain(player)
	or (player.pflags & PF_SLIDING)
	or player.exiting != 0
	or (player.powers[pw_carry] != CR_NONE
	and player.powers[pw_carry] != CR_ROLLOUT)
	or player.spectator
	or player.playerstate != PST_LIVE
	or player.panim == PA_PAIN
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.actionstate
	or player.powers[pw_nocontrol] > 0
	or (player.isxmomentum and player.mo.state == S_PLAY_FACEPLANT)
		if player.milnekick
			P_RestoreMusic(player)
			player.milnekick = 0
			if (player.mo and player.mo.valid)
			and player.mo.state == S_MILNE_KICK
				player.mo.state = S_PLAY_WALK
			end
		end
	elseif player.milnekick
		if (player.milnekick == 1 and player.mo.skin != "milne")
		or not (P_IsObjectOnGround(player.mo) or player.powers[pw_super]
		or player.powers[pw_justlaunched] or player.powers[pw_carry] == CR_ROLLOUT)
		or player.milne3tapping or not P_IsValidSprite2(player.mo, SPR2_FKIK)
			P_RestoreMusic(player)
			player.milnekick = 0
			if (player.mo and player.mo.valid)
			and player.mo.state == S_MILNE_KICK
				player.mo.state = S_PLAY_WALK
			end
		else
			if (player.mo.frame == A or player.mo.frame == E)
			and player.mo.state == S_MILNE_KICK and not player.powers[pw_super]
				player.mo.friction = FRACUNIT/8
			else
				player.mo.friction = FRACUNIT
			end
			if player.mo.state != S_MILNE_KICK
				player.mo.state = S_MILNE_KICK
				player.mo.frame = D
			end
			//Super Speed
			if player.powers[pw_super]
				local stupid = ((leveltime%4)*2)-1
				if stupid < 0 or stupid > 7
					stupid = 7
				end
				player.mo.frame = stupid
				P_SpawnGhostMobj(player.mo)
			else
				player.pflags = $|PF_JUMPSTASIS
			end
		end
	elseif (P_IsObjectOnGround(player.mo) or player.powers[pw_super]
	or player.powers[pw_justlaunched] or player.powers[pw_carry] == CR_ROLLOUT)
	and not player.crystallance and not (player.pflags&PF_SPINNING)
	and not (player.pflags&PF_BOUNCING) and P_IsValidSprite2(player.mo, SPR2_FKIK)
	and not (player.milnecarry and player.milnecarry.valid)
		if player.mo.milnejoin and player.mo.milnejoin.valid
			P_SpawnLockOn(player, player.mo.milnejoin, S_MILNE_JOIN)
		end
		
		if (player.mo.skin == "milne" or (player.mo.milnejoin and player.mo.milnejoin.valid))
		and player.milne3tapping
			P_PlayJingleMusic(player, "MILNEKICK", nil, true, JT_OTHER)
			player.mo.state = S_MILNE_KICK
			if player.mo.milnejoin and player.mo.milnejoin.valid
				player.milnekick = 2
				player.mo.frame = player.mo.milnejoin.frame
				player.mo.tics = player.mo.milnejoin.tics
			else
				player.milnekick = 1
			end
		end
	end
	
	if player.mo and player.mo.valid
		player.mo.milnejoin = nil
	end
	
	//Crystal Foxes only past this point!
	if not (player.mo and player.mo.valid and player.mo.skin == "milne")
		//Reset the object you're carrying
		if player.milnecarry and player.milnecarry.valid
			DropMilneCarry(player, false)
		end
	return end
	
	if player.hugged and player.hugged.valid
	and player.hugged.mo and player.hugged.mo.valid
	and (player.hugged.hugging == player or player.hugged.hug == player)
	and player.hugged.mo.skin != "cacee"
	and not player.hugged.powers[pw_flashing]
	and not player.hugged.powers[pw_invulnerability]
	and not player.hugged.powers[pw_super]
		player.milnehugpain = $+1
		if player.milnehugpain >= 5
			player.hugged.hugging = nil
			player.hugged.hug = nil
			local thok = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_THOK)
			thok.flags2 = $|MF2_DONTDRAW
			thok.tics = 2
			thok.name = player.name.."'s sharp crystal body"
			P_DamageMobj(player.hugged.mo, thok, thok)
			
			S_StopSoundByID(player.hugged.mo, sfx_altdi1)
			S_StopSoundByID(player.hugged.mo, sfx_altdi2)
			S_StopSoundByID(player.hugged.mo, sfx_altdi3)
			S_StopSoundByID(player.hugged.mo, sfx_altdi4)
			S_StartSound(player.hugged.mo, sfx_spkdth)
			
			player.hugged = nil
			player.milnehugpain = TICRATE/2
		end
	elseif player.milnehugpain
		player.milnehugpain = $-1
	end
	
	if player.powers[pw_underwater]
		player.powers[pw_underwater] = underwatertics
	end
	if player.powers[pw_spacetime]
		player.powers[pw_spacetime] = spacetimetics
	end
		
	//Break walls and floors during the Thok
	if player.mo.state == S_PLAY_SPINDASH
	or player.crystallance > 0 or player.climbing
	and not (player.milnecarry and player.milnecarry.valid)
		if not PF_CANBUSTFLOORS
			local sectorthing = P_PlayerTouchingSectorSpecial(player, 0, 0)
			if sectorthing and sectorthing.valid then
				for fof in sectorthing.ffloors()
					if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
					and (abs(fof.topheight - player.mo.z) <= 40*player.mo.scale) then
						EV_CrumbleChain(player.sectorthing, fof)
					end
				end
			end
		end
		if player.charability == CA_NONE
			player.charability = CA_GLIDEANDCLIMB
			if SF_CANBUSTWALLS
				player.charflags = $|SF_CANBUSTWALLS
			end
			if PF_CANBUSTFLOORS
				player.pflags = $|PF_CANBUSTFLOORS
			end
		end
	elseif player.charability == CA_GLIDEANDCLIMB
		player.charability = CA_NONE
		if SF_CANBUSTWALLS
			player.charflags = $&~SF_CANBUSTWALLS
		end
		if PF_CANBUSTFLOORS
			player.pflags = $&~PF_CANBUSTFLOORS
		end
	end
	
	//Detect when we press Custom 1
	if not (player.cmd.buttons & BT_CUSTOM1)
		player.milne1tapready = true
		player.milne1tapping = false
	elseif player.milne1tapready then
		player.milne1tapping = true
		player.milne1tapready = false
	else
		player.milne1tapping = false
	end
	
	//Disallows the rest of the code in certain circumstances
	if P_PlayerInPain(player)
	or (player.pflags & PF_SLIDING)
	or player.exiting != 0
	or (player.powers[pw_carry] != CR_NONE
	and player.powers[pw_carry] != CR_ROLLOUT
	and player.powers[pw_carry] != CR_MINECART)
	or player.spectator
	or player.playerstate != PST_LIVE
	or not player.mo.health
	or player.panim == PA_PAIN
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.actionstate
	or player.powers[pw_nocontrol] > 0
	or (player.isxmomentum and player.mo.state == S_PLAY_FACEPLANT)
		if player.milnekick
			P_RestoreMusic(player)
			player.milnekick = 0
		end
		
		if player.powers[pw_carry] == CR_ROPEHANG
			player.weapondelay = max($, 1)
		end
		
		//Remember being in a whirlwind or swing
		if player.powers[pw_carry] == CR_DUSTDEVIL
		or player.powers[pw_carry] == CR_MACESPIN
			player.milnewhirlwind = 1
		else
			player.milnewhirlwind = 0
		end
		
		player.milnespringtime = 0
		player.mo.milnesteam = 0
		player.milnemomz = 0
		player.crystallance = 0
		player.milneairtime = 0
		
		//Reset the object you're carrying
		if player.milnecarry and player.milnecarry.valid
			DropMilneCarry(player, false)
		end

		//Death Effect
		if player.playerstate == PST_DEAD then
			if player.milnedeadtimer < 7
				if player.milnedeadtimer == 0
					local ghost = P_SpawnGhostMobj(player.mo)
					ghost.sprite2 = SPR2_DRWN
					ghost.tracer = player.mo
					ghost.flags2 = $|MF2_LINKDRAW
					ghost.fuse = TICRATE
				end
				P_SetScale(player.mo, player.mo.scale+(player.milnedeadtimer*player.mo.destscale/28))
			elseif player.milnedeadtimer == 7
				S_StartSound(player.mo, sfx_crysha)
				//Spawn the explosions
				local i = 0 while i < 16
					local explode = P_SpawnMobjFromMobj(player.mo,0,0,player.mo.height/2,MT_SHATTERCRYSTAL)
					if explode and explode.valid
						explode.scale = player.mo.destscale*3/2
						explode.fuse = TICRATE*3
						explode.angle = (ANGLE_22h*i)+ANGLE_180
						explode.rollangle = FixedAngle(P_RandomKey(360)*FRACUNIT)
						explode.threshold = P_RandomKey(2)
						P_InstaThrust(explode,explode.angle,8*FRACUNIT)
						explode.momz = explode.momx+(P_GetMobjGravity(explode)*-4)
						P_InstaThrust(explode,(player.cmd.angleturn<<16)+ANGLE_90,explode.momy)
						explode.type = MT_SONIC3KBOSSEXPLODE
						explode.flags = $&~MF_SCENERY
					end
					i = $+1
				end
				P_SpawnMobjFromMobj(player.mo,0,0,player.height/2,MT_MILNE_CORE)
				player.mo.flags2 = $ | MF2_DONTDRAW
			end
			//Make her invisible and not move off the map
			player.mo.momz = P_GetMobjGravity(player.mo)*-1
			player.mo.flags = $ | MF_NOGRAVITY & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
			
			player.milnedeadtimer = $+1
		elseif P_PlayerInPain(player)
			if not player.milnedeadtimer
				S_StartSoundAtVolume(player.mo, sfx_s3k9e, 128)
				S_StartSound(player.mo, sfx_s3k7c)
				local i = 0 while i < 4
					local explode = P_SpawnMobjFromMobj(player.mo,0,0,player.height*2/3,MT_SHATTERCRYSTAL)
					if explode and explode.valid
						explode.scale = player.mo.scale/2
						explode.threshold = P_RandomKey(2)
						P_InstaThrust(explode, player.drawangle+ANGLE_45-((ANGLE_22h)*i), 5*player.mo.scale)
						P_SetObjectMomZ(explode, 10*FRACUNIT, false)
						explode.fuse = TICRATE*3
					end
					i = $+1
				end
				player.milnedeadtimer = -1
			end
		elseif player.milnedeadtimer
			player.milnedeadtimer = 0
		end
	return end
	
	if player.milnedeadtimer
		player.milnedeadtimer = 0
	end
	
	if player.crystallance or player.mo.state == S_PLAY_FIRE
	or player.mo.state == S_PLAY_FIRE_FINISH
		player.canguard = false
	end
	
	//This is kinda dumb, but whatever
	if player.mo.state == S_PLAY_FIRE_FINISH and player.mo.tics == 1
	and not player.weapondelay
		if not P_IsObjectOnGround(player.mo) and not player.powers[pw_carry]
			player.mo.state = S_PLAY_FALL
		elseif player.speed
			player.mo.state = S_PLAY_WALK
		end
	end
	
	//Same here
	if player.pflags&PF_JUMPED and player.powers[pw_carry] == CR_ROLLOUT
		player.pflags = $&~PF_JUMPED
	end
	
	//Milne is pretty heavy...
	if player.powers[pw_carry]
		player.mo.milnesteam = false
		player.milnewhirlwind = 0
	//Delay the dust devil boost
	elseif player.milnewhirlwind == 1
		player.milnewhirlwind = $+1
	//Spring Boost
	elseif (player.mo.eflags & MFE_SPRUNG) or player.mo.milnesteam
	or player.milnewhirlwind
		player.mo.momz = $*GRAVITYMUL/GRAVITYDIV
		player.mo.momx = $*GRAVITYMUL/GRAVITYDIV
		player.mo.momy = $*GRAVITYMUL/GRAVITYDIV
		player.mo.milnesteam = false
		player.milnewhirlwind = 0
	//Increased Gravity
	elseif not (P_IsObjectOnGround(player.mo) or player.mo.eflags&MFE_JUSTHITFLOOR
	or player.mo.eflags&MFE_GOOWATER)
		player.mo.momz = $+P_GetMobjGravity(player.mo)/2
		if player.mo.momz == 0
			player.mo.momz = $-P_MobjFlip(player.mo)
		end
	end
	//Landing shake
	if P_IsObjectOnGround(player.mo) or player.mo.eflags&MFE_JUSTHITFLOOR
	or player.milneairtime == nil or player.powers[pw_carry]
		if player.milneairtime and player.milneairtime >= 5
		and player.mo.eflags&MFE_JUSTHITFLOOR
		and player.milnemomz <= -20*player.mo.scale
			if player.milnemomz != nil and player.milnemomz <= -40*player.mo.scale
			and not player.milnespringtime
				S_StartSound(player.mo, sfx_s3k4c)
				S_StartSound(player.mo,sfx_s3k5f)
				P_Earthquake(player.mo,player.mo,RING_DIST)
				if player == displayplayer
					P_StartQuake(max(min(player.speed*2, 64*FRACUNIT), 32*FRACUNIT), 2)
				end
			elseif player == displayplayer
				S_StartSoundAtVolume(player.mo, sfx_s3k4c, 128)
				S_StartSoundAtVolume(player.mo, sfx_s3k49, 96)
				P_StartQuake(max(min(player.speed, 24*FRACUNIT), 12*FRACUNIT), 2)
			end
		end
		player.milneairtime = 0
	else
		player.milnemomz = player.mo.momz*P_MobjFlip(player.mo)
		player.milneairtime = $+1
	end
	
	local lockon
	//Handle the carrying junk
	if player.milnecarry and player.milnecarry.valid
	
		//If Milne is spinning...
		//No. Stop. Get some help.
		if player.pflags&PF_SPINNING
			player.pflags = $&~PF_SPINNING
		end
		
		local flystate = S_PLAY_FLY
		if player.mo.eflags & MFE_UNDERWATER
			flystate = S_PLAY_SWIM
		end
		
		//Do the Milne's carrying animation
		local runspeed = FixedMul(player.runspeed, player.mo.scale)
		//Spring
		if (player.mo.state == S_PLAY_SPRING
		or player.mo.state == S_PLAY_JUMP)
		and not player.powers[pw_carry]
			player.mo.state = S_PLAY_TWINSPIN
			player.mo.tics = -1
			player.panim = PA_ETC
		//Fall
		elseif (player.mo.state == S_PLAY_TWINSPIN
		or player.mo.state == S_PLAY_FALL)
		and not player.powers[pw_carry]
			if player.mo.momz*P_MobjFlip(player.mo) < 0
			or player.mo.state == S_PLAY_FALL
				player.mo.state = S_PLAY_MELEE_LANDING
				player.mo.tics = -1
				player.panim = PA_FALL
			end
		//Fall speed
		elseif player.mo.state == S_PLAY_MELEE_LANDING
		and not player.powers[pw_carry]
			local momz = abs(player.mo.momz)
			if (momz >= runspeed/2 and not (leveltime%2))
			or (momz < runspeed/2 and momz >= runspeed/4 and not (leveltime%3))
			or (momz < runspeed/4 and not (leveltime%4))
				player.mo.state = S_PLAY_MELEE_LANDING
				player.mo.tics = -1
				player.panim = PA_FALL
			end
		//Skid
		elseif player.skidtime
			player.mo.state = flystate
			player.mo.frame = 7
		//Stand
		elseif (player.speed == 0
		and (P_IsObjectOnGround(player.mo) or player.powers[pw_carry]))
		or player.powers[pw_carry] == CR_MINECART
			player.mo.state = S_PLAY_GLIDE_LANDING
		//Run
		elseif player.speed >= runspeed and not player.powers[pw_carry]
			player.mo.state = S_PLAY_FLY_TIRED
			if player.speed >= runspeed*2
				player.mo.frame = leveltime%4
			else
				player.mo.frame = (leveltime%8)/2
			end
		//Walk
		elseif player.mo.state != flystate
		or (player.speed >= runspeed/2 and not (leveltime%2))
		or (player.speed < runspeed/2 and player.speed >= runspeed/4 and not (leveltime%3))
		or (player.speed < runspeed/4 and not (leveltime%4))
			player.mo.state = flystate
			player.mo.tics = -1
			player.panim = PA_ETC
		end
		
		//Reset the rollangle for whatever you're carrying
		if player.milnecarry.rollangle != 0
			player.milnecarry.rollangle = 0
		end
		
		//Set the angle and animation
		//But, if the player we're carrying is jumping, set them free
		if player.milnecarry.player
			if player.milnecarry.player.pflags&PF_JUMPED
				local prevcarry = player.milnecarry
				DropMilneCarry(player, false)
				prevcarry.player.pflags = $|PF_JUMPED&~PF_SPINNING
				prevcarry.player.jumping = true
				prevcarry.state = S_PLAY_JUMP
				return
			end
			player.milnecarry.player.drawangle = player.drawangle
			
			//Milne uses carry type 13, which is unused normally
			//Except when Yoshi uses it
			player.milnecarry.tracer = player.mo
			player.milnecarry.player.powers[pw_carry] = 13
			
			if gametyperules&GTR_FRIENDLY or
			(G_GametypeHasTeams() and player.milnecarry.player.ctfteam == player.ctfteam)
				player.milnecarry.state = S_PLAY_ROLL
			else
				player.milnecarry.state = S_PLAY_PAIN
			end
		else
			player.milnecarry.angle = player.drawangle
			if player.milnecarry.type == MT_ROLLOUTROCK
				player.milnecarry.fuse = player.milnecarry.info.painchance
			elseif player.milneprevflags&MF_SPRING
				player.milnecarry.fuse = 0
			end
		end
		
		//Set the momentum
		player.milnecarry.momx = player.mo.momx
		player.milnecarry.momy = player.mo.momy
		player.milnecarry.momz = player.mo.momz
		
		//Get the vertical offset
		local zoffset = player.mo.scale
		if player.mo.state == S_PLAY_TWINSPIN
			zoffset = $+player.mo.scale
		elseif player.mo.state == S_PLAY_MELEE_LANDING
			zoffset = $-player.mo.scale
		elseif player.mo.state == flystate
			if player.mo.frame&FF_FRAMEMASK == 0
			or player.mo.frame&FF_FRAMEMASK == 4
				zoffset = $+4*player.mo.scale
			elseif player.mo.frame&FF_FRAMEMASK == 2
			or player.mo.frame&FF_FRAMEMASK == 6
				zoffset = $+player.mo.scale
			else
				zoffset = $+2*player.mo.scale
			end
		elseif player.mo.state == S_PLAY_FLY_TIRED
			zoffset = $-(2+(player.mo.frame&FF_FRAMEMASK)%2)*player.mo.scale
		end
		
		//Set the position
		local zdist
		P_TryMove(player.milnecarry, player.mo.x, player.mo.y, true)
		if player.mo.flags2&MF2_OBJECTFLIP
			player.milnecarry.flags2 = $|MF2_OBJECTFLIP
			player.milnecarry.z = player.mo.z-zoffset-player.milnecarry.height
			zdist = player.mo.z - (player.milnecarry.z + player.milnecarry.height)
		else
			player.milnecarry.flags2 = $&~MF2_OBJECTFLIP
			player.milnecarry.z = player.mo.z+player.mo.height+zoffset
			zdist = (player.mo.z + player.mo.height) - player.milnecarry.z
		end
		
		//If the object is too far away even after moving, just drop what we're carrying
		local dist = P_AproxDistance(player.mo.x-player.milnecarry.x, player.mo.y-player.milnecarry.y)
		dist = P_AproxDistance(dist, zdist)
		if dist > player.mo.radius*2 and not player.weapondelay
			DropMilneCarry(player, false)
			return
		end
		
		//Spawn a lockon reticle if we can
		local lockon = P_LookForEnemies(player, false,
		not(player.milneprevflags&MF_PUSHABLE or player.milneprevflags&MF_SPRING
		or (player.milnecarry.player and player.milnecarry.player.bot)))
		
		if lockon and lockon.valid
		and (player.milneprevflags&MF_ENEMY or player.milneprevflags&MF_MONITOR
		or player.milneprevflags&MF_PUSHABLE or player.milneprevflags&MF_SPRING
		or (player.milnecarry.player and (gametyperules&GTR_FRIENDLY or
		(G_GametypeHasTeams() and player.milnecarry.player.ctfteam == player.ctfteam))))
			P_SpawnLockOn(player, lockon, S_LOCKON1)
		end
		
		return
	end
	
	//Lance state...
	if player.crystallance > 0 or player.climbing or player.pflags&PF_GLIDING
		player.mo.state = S_PLAY_GLIDE
		if player.crystallance > LANCETIME
			player.mo.sprite2 = SPR2_CLMB
		end
	end
	
	//Lance Time
	if player.crystallance
		player.skidtime = 0
		if player.mo.eflags & MFE_SPRUNG
			player.crystallance = 0
			player.mo.state = S_PLAY_SPRING
		elseif player.crystallance == 1
		or (player.climbing and player.crystallance > 0)
		or ((player.pflags&PF_STARTJUMP or player.milnespringtime)
		and player.crystallance > 0 and player.crystallance <= LANCETIME)
			if player.powers[pw_super]
				player.crystallance = 0
			else
				player.crystallance = -1
			end
				
			if player.climbing
				if lines[player.lastlinehit] and lines[player.lastlinehit].valid
					local x,y = P_ClosestPointOnLine(player.mo.x, player.mo.y, lines[player.lastlinehit])
					player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, x, y)
					for i=0, 32
						P_TryMove(player.mo, player.mo.x+P_ReturnThrustX(nil,player.mo.angle,player.mo.scale),
						player.mo.y+P_ReturnThrustY(nil,player.mo.angle,player.mo.scale), true)
					end
				end
				S_StopSoundByID(player.mo, sfx_mllnc2)
				S_StartSound(player.mo, sfx_mllnc3)
				S_StartSoundAtVolume(player.mo, sfx_shattr, 128)
				local i = 0 while i < 4
					local explode = P_SpawnMobjFromMobj(player.mo,0,0,player.height*2/3,MT_SHATTERCRYSTAL)
					if explode and explode.valid
						explode.scale = player.mo.scale/2
						explode.threshold = P_RandomKey(2)
						P_InstaThrust(explode, player.mo.angle+ANGLE_180+ANGLE_22h-((ANGLE_11hh)*i), 5*player.mo.scale)
						P_SetObjectMomZ(explode, 10*FRACUNIT, false)
						explode.fuse = TICRATE*3
					end
					i = $+1
				end
				if P_IsObjectOnGround(player.mo)
					player.mo.z = $+P_MobjFlip(player.mo)
				end
			else
				player.mo.momx = $/2
				player.mo.momy = $/2
				if player.milnespringtime
					player.mo.state = S_PLAY_SPINDASH
				elseif player.pflags&PF_STARTJUMP
					player.mo.state = S_PLAY_JUMP
				else
					player.mo.state = S_PLAY_FALL
				end
			end
		elseif player.crystallance > 0
			player.pflags = $|PF_STASIS
			if player.crystallance > LANCETIME
				player.pflags = $|PF_JUMPSTASIS|PF_JUMPDOWN
				P_InstaThrust(player.mo, player.mo.angle, -16*player.mo.scale)
			else
				if P_IsObjectOnGround(player.mo)
					player.pflags = $&~PF_JUMPED|PF_GLIDING
				else
					player.pflags = $|PF_JUMPED|PF_GLIDING
				end
				if player.powers[pw_pushing]
					P_InstaThrust(player.mo, player.mo.angle, 25*player.mo.scale)
				elseif (player.isxmomentum
				and player.powers[pw_super] and player.hyper.capable)
					P_InstaThrust(player.mo, player.mo.angle, 100*player.mo.scale)
				elseif player.powers[pw_super]
					P_InstaThrust(player.mo, player.mo.angle, 75*player.mo.scale)
				else
					P_InstaThrust(player.mo, player.mo.angle, 50*player.mo.scale)
				end
				if player.crystallance == LANCETIME
					S_StartSound(player.mo, sfx_mllnc2)
				end
				if leveltime%2
					P_SpawnGhostMobj(player.mo)
				end
			end
			player.mo.angle = player.mo.angle
			player.drawangle = player.mo.angle
			player.mo.momz = 0
			if player.crystallance < LANCETIME and player.powers[pw_super]
			and (player.cmd.buttons & BT_CUSTOM1 or player.cmd.buttons & BT_SPIN)
				player.crystallance = 2
			else
				player.crystallance = $-1
			end
		elseif P_IsObjectOnGround(player.mo) or player.mo.eflags&MFE_JUSTHITFLOOR
			player.crystallance = 0
		end
	elseif player.milne1tapping and not player.milnekick
	and not player.milne3tapping and not player.powers[pw_carry]
	and not srb2p
		startcrystallance(player)
	end
	
	//Get a boost from thokking into springs, plus do the afterimage
	if player.milnespringtime
		local ghost = P_SpawnGhostMobj(player.mo)
		ghost.scale = $-(TICRATE-player.milnespringtime*5/2)*$*2/TICRATE
		ghost.z = $+(TICRATE/2-player.milnespringtime)*player.mo.scale*3
		ghost.frame = 0
		ghost.colorized = true
		ghost.momx = player.mo.momx/2
		ghost.momy = player.mo.momy/2
		if player.milnespringtime == TICRATE/2
			ghost.color = SKINCOLOR_SUPERPURPLE1
		else
			ghost.color = SKINCOLOR_SUPERPURPLE5
		end
		if (player.mo.eflags & MFE_SPRUNG)
			player.milnespringtime = 0
			player.mo.momz = $*5/4
			player.mo.momx = $*5/4
			player.mo.momy = $*5/4
			S_StartSound(player.mo, sfx_sprong)
			if (player.mo.eflags & MFE_UNDERWATER)
				local ex = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_UWEXPLODE)
				if ex and ex.valid ex.scale = $/2 end
			else
				P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.scale*P_MobjFlip(player.mo), MT_SPINDUST)
			end
		elseif P_IsObjectOnGround(player.mo) or player.mo.state != S_PLAY_SPINDASH
			player.milnespringtime = 0
		else
			player.milnespringtime = $-1
		end
	end
	
	//Make the spinning animation go faster when we're above our normalspeed
	if player.mo.state == S_PLAY_SPINDASH and player.mo.tics == 2
	and player.speed >= FixedMul(player.normalspeed, player.mo.scale)
		if player.speed >= FixedMul(player.normalspeed*2, player.mo.scale)
		and (player.mo.frame&FF_FRAMEMASK)%2
			player.mo.state = S_PLAY_SPINDASH
		end
		player.mo.tics = 1
	end
end)

//Awesome
addHook("ShouldJingleContinue", function(player, musname)
	if true return end
	if musname != "MILNEKICK" return end
	if player and player.mo and player.mo.skin == "milne" and player.milnekick
		return true
	else
		return false
	end
end)

//Double Jump Thok
//Give this a cool name later
//...we never gave it a cool name :(
//Sike we did :] Twister Thok is born!
addHook("AbilitySpecial", function(player)
	if not (player.mo and player.mo.skin == "milne") return end
	
	//Don't do it if you're holding the button, used a shield
	//are carrying something, or didn't even jump
	if player.pflags&PF_JUMPDOWN or player.pflags&PF_SHIELDABILITY
	or (player.milnecarry and player.milnecarry.valid)
	or not (player.pflags&PF_JUMPED) return true end
	
	//The downwards jump
	if player.pflags&PF_THOKKED
		if player.powers[pw_super]
			player.pflags = $&~PF_THOKKED
		else
			player.pflags = $&~PF_JUMPED
		end
		
		if player.mo.eflags&MFE_UNDERWATER
			P_SetObjectMomZ(player.mo, -12*FRACUNIT, true)
		else
			P_SetObjectMomZ(player.mo, -15*FRACUNIT, true)
		end
		
		if mariomode
			S_StartSound(player.mo, sfx_thok)
		else
			S_StartSound(player.mo, sfx_mldown)
		end
	//The upwards jump
	else
		player.pflags = $&~PF_JUMPED
		P_DoJump(player, false)
		player.pflags = $|PF_JUMPED|PF_THOKKED
		player.jumping = true
		S_StartSound(player.mo, sfx_thok)
	end
	
	//The Thok part (only executes if you're holding far enough in a direction)
	if not (P_GetPlayerControlDirection(player) == 0
	or (abs(player.cmd.forwardmove) < 35 and abs(player.cmd.sidemove) < 35))
		local actionspd = max(player.actionspd, player.normalspeed)
		if player.mo.eflags&MFE_UNDERWATER
			actionspd = $*2/3
		end
		
		if player.speed <= FixedMul(actionspd, player.mo.scale)
			P_InstaThrust(player.mo, player.mo.angle, FixedMul(actionspd, player.mo.scale))
		else
			P_InstaThrust(player.mo, player.mo.angle, FixedHypot(player.rmomx,player.rmomy))
		end
		player.drawangle = player.mo.angle
	end
	
	//Other stuff
	player.mo.state = S_PLAY_SPINDASH
	//P_SpawnThokMobj(player)
	player.pflags = $&~PF_SPINNING&~PF_STARTDASH
	player.milnespringtime = TICRATE/2
	return true
end)

//Allows you to attack using the Thok
addHook("PlayerCanDamage", function(player, mobj)
	if not (player.mo and player.mo.skin == "milne") return end
	
	if player.mo.state == S_PLAY_SPINDASH
		return true
	end
end)

//Destroy spikes via the Thok, Crystal Lance, and thrown objects
local waterspike = function(thing, tmthing)
	if not (thing and thing.valid and tmthing and tmthing.valid) return end
	if (tmthing.milnethrown or (tmthing.player and tmthing.skin == "milne"
	and (tmthing.state == S_PLAY_SPINDASH or tmthing.player.crystallance > 0)))
	and thing.z - thing.scale <= tmthing.z + tmthing.height + tmthing.momz
	and thing.z + thing.height + thing.scale >= tmthing.z + tmthing.momz
		bouncethrown(tmthing, false, true)
		P_KillMobj(thing, tmthing)
		return true
	end
end
addHook("MobjCollide", function(thing, tmthing) waterspike(thing, tmthing) end, MT_SPIKE)
addHook("MobjCollide", function(thing, tmthing) waterspike(thing, tmthing) end, MT_WALLSPIKE)

//Make thrown objects break walls
local eggwallbreak = function(mobj, sectorthing)
	local nerds = false
	for fof in sectorthing.ffloors()
		if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
			local foffloor = fof.topheight
			local fofceiling = fof.bottomheight
			if fof.b_slope and fof.b_slope.valid
				fofceiling = P_GetZAt(fof.b_slope, mobj.x, mobj.y)
			end
			if fof.t_slope and fof.t_slope.valid
				foffloor = P_GetZAt(fof.t_slope, mobj.x, mobj.y)
			end
			if foffloor >= mobj.z and fofceiling <= mobj.z+mobj.height
				EV_CrumbleChain(nil, fof)
				if fof.master.flags & ML_EFFECT5
					P_LinedefExecute(P_AproxDistance(fof.master.dx, fof.master.dy)>>FRACBITS, mobj, sectorthing)
				end
				return true
			end
		end
	end
end

//Egg Wall Breaker
addHook("MobjLineCollide", function(mobj, line)
	if not (mobj and mobj.valid and mobj.milnethrown and line and line.valid) then return end
	local killone
	local killtwo
	if line.frontsector and line.frontsector.valid then killone = eggwallbreak(mobj, line.frontsector) end
	if line.backsector and line.backsector.valid then killtwo = eggwallbreak(mobj, line.backsector) end
	if (killone or killtwo) and not (mobj.flags&MF_NOGRAVITY) then
		bouncethrown(mobj, true)
	end
end)

//Screw it, make ALL pushables hurt enemies if they're off the ground
addHook("MobjCollide", function(thing, tmthing)
	if thing and thing.valid and thing.health and thing.flags&MF_ENEMY
	and tmthing and tmthing.valid and tmthing.flags&MF_PUSHABLE and not tmthing.battleobject
	and not P_IsObjectOnGround(tmthing)
	and thing.z - thing.scale <= tmthing.z + tmthing.height
	and thing.z + thing.height + thing.scale >= tmthing.z
		thing.momz = abs($/2)*P_MobjFlip(thing)
		P_DamageMobj(thing, tmthing, tmthing, 1)
	end
end)

//Prevent pushable crushing
addHook("ShouldDamage", function(target, n,a,h, damagetype)
	if target and target.valid and target.player and target.skin == "milne"
	and target.state == S_PLAY_FIRE and damagetype == DMG_CRUSHED
		return false
	end
end, MT_PLAYER)

//Make thrown springs sprong other objects
addHook("MobjMoveCollide", function(tmthing, thing)
	if tmthing and tmthing.valid and tmthing.flags&MF_SPRING and tmthing.milnethrown
	and thing and thing.valid and thing.health and (thing.milnethrown
	or thing.flags&MF_ENEMY or thing.flags&MF_BOSS or thing.flags&MF_PUSHABLE
	or thing.flags&MF_SPRING)
	and thing.z - thing.scale <= tmthing.z + tmthing.height
	and thing.z + thing.height + thing.scale >= tmthing.z
		if thing.flags&MF_SPRING
			P_DoSpring(thing, tmthing)
		else
			P_DoSpring(tmthing, thing)
			tmthing.momx = 0
			tmthing.momy = 0
			tmthing.momz = 0
		end
	end
end)

//Respawn thrown springs
addHook("MobjFuse", function(mobj)
	if mobj.milnerespawn
		if mobj.milnerespawn == -1
			P_SpawnGhostMobj(mobj)
			P_RemoveMobj(mobj)
		elseif mobj.milnerespawn == 1 or mobj.milnerespawn == -2
			mobj.fuse = TICRATE/2
			S_StartSound(mobj, sfx_monton)
			local i = 0 while i < 16
				local explode = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_DUST)
				if explode and explode.valid
					explode.tics = $*4
					explode.angle = (ANGLE_22h*i)+ANGLE_180
					P_InstaThrust(explode,explode.angle,4*FRACUNIT)
					
					P_TeleportMove(explode, explode.x+explode.momx*TICRATE/2,
					explode.y+explode.momy*TICRATE/2, explode.z+explode.momz*TICRATE/2)
					explode.momx = $*-1
					explode.momy = $*-1
					explode.momz = $*-1
				end
				i = $+1
			end
			mobj.milnerespawn = $+1
		else
			mobj.flags = $&~MF_NOCLIPTHING
			mobj.flags2 = $&~MF2_DONTDRAW
			mobj.milnerespawn = 0
		end
		return true
	end
end)

//Make Milne-thrown objects bounce off their targets
addHook("MobjDamage", function(target, inflictor)
	if inflictor and inflictor.valid and inflictor.milnethrown
	and not (inflictor.flags&MF_NOGRAVITY)
		bouncethrown(inflictor, false)
	end
end)

//If you're throwing or are holding an object, shields can't be used
addHook("ShieldSpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "milne"
		if player.mo.state == S_PLAY_FIRE
		or (player.milnecarry and player.milnecarry.valid)
			return true
		end
	end
end)

//Throw an object we're carrying, look for a new object to pick up, or do the Crystal Toss
addHook("SpinSpecial", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "milne") return end
	
	if P_PlayerInPain(player)
	or (player.pflags & PF_SLIDING)
	or player.exiting != 0
	or (player.powers[pw_carry] != CR_NONE
	and player.powers[pw_carry] != CR_ROLLOUT
	and player.powers[pw_carry] != CR_MINECART)
	or player.spectator
	or player.playerstate != PST_LIVE
	or not player.mo.health
	or player.panim == PA_PAIN
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.actionstate
	or player.powers[pw_nocontrol] > 0
	or player.milnekick
	or player.crystallance > 0
	or player.climbing
	or player.pflags&PF_USEDOWN
	or srb2p
	or (player.isxmomentum and (player.mo.state == S_PLAY_TRICKUP
	or player.mo.state == S_PLAY_TRICKDOWN))
	or P_SuperReady(player) return end
	
	//Throw the object we're carrying
	if player.milnecarry and player.milnecarry.valid
		S_StartSound(player.mo, sfx_mltoss)
		player.mo.state = S_PLAY_FIRE
		player.mo.tics = 3
		player.drawangle = player.mo.angle
		player.weapondelay = TICRATE/2
		
		DropMilneCarry(player, true)
		
	//Look for an object to carry
	else
		local maxdist = FixedMul(RING_DIST/3, player.mo.scale)+player.speed
		local span = ANGLE_45
		local thokmobj = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_THOK)
		thokmobj.radius = maxdist
		local closestmo = nil
		local closestdist = 0
		
		if CBW_Battle and CBW_Battle.BattleGametype()
		and not (gametyperules&GTR_FRIENDLY)
			maxdist = $/2
		end

		searchBlockmap("objects", function(refmobj, mo)
			local trash = R_PointToAngle2(player.mo.x, player.mo.y, mo.x, mo.y)
		
			if mo.flags & MF_NOCLIPTHING or mo.health <= 0
			or mo == player.mo or mo.flags2 & MF2_FRET or not P_CheckSight(player.mo, mo)
			or ((twodlevel or player.mo.flags2 & MF2_TWOD) and abs(player.mo.y-mo.y) > player.mo.radius)
			or ((trash - player.mo.angle > span) or (trash - player.mo.angle < -1*span))
			or (player.powers[pw_carry] and player.mo.tracer == mo)
			return end
			
			if mo.player
				if not milneable or player.bot == 1
				or mo.player.spectator or mo.player.panim == PA_PAIN or G_TagGametype()
				or mo.player.powers[pw_invulnerability] > 1
				or (mo.player.powers[pw_super] and not (gametyperules&GTR_FRIENDLY))
				or mo.player.powers[pw_flashing]
					return
				//No picking up attacking players in Battle
				elseif CBW_Battle
					CBW_Battle.DoSPriority(mo.player, player.mo)
					if mo.player.battle_def then return end
				end
			elseif mo.flags&MF_MONITOR
				if (mo.flags&MF_GRENADEBOUNCE)
				or (mo.type == MT_RING_REDBOX and player.ctfteam != 1)
				or (mo.type == MT_RING_BLUEBOX and player.ctfteam != 2)
					return
				end
			elseif mo.type == MT_YELLOWBOOSTER or mo.type == MT_REDBOOSTER
			or mo.type == MT_BANPSPRING or mo.type == MT_CYBRAKDEMON_ELECTRIC_BARRIER
				return
			elseif not stronk
			and not ((mo.flags&(MF_ENEMY|MF_BOSS) and mo.health == 1 and mo.type != MT_YELLOWSHELL)
			or ((mo.info.flags&MF_PUSHABLE or mo.flags&MF_SPRING or mo.type == MT_ROLLOUTROCK)
			and mo.type != MT_MINECART and milneable))
				return // not a valid target
			end
		
			local zdist = ((player.mo.z + player.mo.height/2) - (mo.z + mo.height/2))*3/2
			local dist = P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y)
			if ((R_PointToAngle2(0, 0, dist, zdist) + span) > span*2) and ((R_PointToAngle2(0, 0, dist, -1*zdist) + span) > span*2)
				return // Don't home outside of desired angle!
			end

			dist = P_AproxDistance(dist, zdist)
			if (dist > maxdist) or (closestmo and dist > closestdist)
				return // out of range
			end

			closestmo = mo
			closestdist = dist
		end, thokmobj)
	
		P_RemoveMobj(thokmobj)
		
		if closestmo and closestmo.valid
			if closestmo.player
				if closestmo.player.powers[pw_carry] == CR_ROPEHANG
					closestmo.tracer = nil
				end
				
				P_ResetPlayer(closestmo.player)
				
				//Destroy the player's minecart without killing them
				if closestmo.player.powers[pw_carry] == CR_MINECART
					closestmo.tracer.target = nil
					P_KillMobj(closestmo.tracer, closestmo, player.mo, 0)
				end
				
				//Milne uses carry type 13, which is unused normally
				//Except when Yoshi uses it
				closestmo.tracer = player.mo
				closestmo.player.powers[pw_carry] = 13
				
				if gametyperules&GTR_FRIENDLY or
				(G_GametypeHasTeams() and closestmo.player.ctfteam == player.ctfteam)
					closestmo.state = S_PLAY_ROLL
				else
					closestmo.state = S_PLAY_PAIN
				end
				
			elseif closestmo.type == MT_GSNAPPER
				local dead = closestmo
				closestmo = P_SpawnMobjFromMobj(dead,0,0,0,MT_BLUECRAWLA)
				P_KillMobj(dead)
				P_SetMobjStateNF(closestmo, mobjinfo[MT_GSNAPPER].spawnstate)
				closestmo.tics = -1
				
			elseif closestmo.flags&MF_MONITOR
				if gametype != GT_COOP and multiplayer
				and CV_FindVar("respawnitem").value and not closestmo.milnethrown
					closestmo.state = S_INVISIBLE
					closestmo.flags = $|MF_NOCLIPTHING
					closestmo.fuse = CV_FindVar("respawnitemtime").value*TICRATE + 2
					closestmo = P_SpawnMobjFromMobj(closestmo,0,0,0,closestmo.type)
				end
				player.numboxes = $+1
				closestmo.state = closestmo.info.spawnstate
				
			elseif closestmo.flags&MF_SPRING
				if not closestmo.milnethrown
					closestmo.milnerespawn = 1
					closestmo.flags = $|MF_NOCLIPTHING
					closestmo.flags2 = $|MF2_DONTDRAW
					closestmo.fuse = TICRATE*5
					closestmo = P_SpawnMobjFromMobj(closestmo,0,0,0,closestmo.type)
				end
				closestmo.state = closestmo.info.spawnstate
				
			else
				if closestmo.flags&MF_ENEMY
					if closestmo.tracer and closestmo.tracer.valid and not closestmo.tracer.player
					and closestmo.type != MT_BUMBLEBORE
						if closestmo.tracer.target and closestmo.tracer.target.valid
						and not closestmo.tracer.target.player
							P_KillMobj(closestmo.tracer.target, player.mo, player.mo)
						end
						P_KillMobj(closestmo.tracer, player.mo, player.mo)
						if closestmo.target and closestmo.target.valid and not closestmo.target.player
							P_KillMobj(closestmo.target, player.mo, player.mo)
						end
					end
					closestmo.health = 0
				end
				if closestmo.type == MT_METALSONIC_RACE
				or closestmo.type == MT_METALSONIC_BATTLE
					local new = P_SpawnMobjFromMobj(closestmo,0,0,0,MT_TNTBARREL)
					new.color = closestmo.color
					if closestmo.skin
						new.skin = closestmo.skin
					end
					new.metaldeath = closestmo.type
					P_SetMobjStateNF(new, closestmo.info.spawnstate)
					P_KillMobj(closestmo)
					if closestmo and closestmo.valid
						closestmo.flags2 = $|MF2_DONTDRAW
						P_TeleportMove(closestmo,0,0,FRACUNIT*1024)
					end
					closestmo = new
				elseif closestmo.type == MT_FANG
					P_SetMobjStateNF(closestmo, closestmo.info.painstate)
				elseif closestmo.type == MT_MINUS
					P_SetMobjStateNF(closestmo, closestmo.info.missilestate)
				else
					P_SetMobjStateNF(closestmo, closestmo.info.spawnstate)
				end
				closestmo.tics = -1
			end
			
			player.milneprevflags = closestmo.flags
			closestmo.flags = MF_NOCLIPTHING|MF_SLIDEME|MF_NOGRAVITY
			closestmo.flags2 = $&~MF2_DONTDRAW
			
			player.weapondelay = TICRATE/5
			S_StartSoundAtVolume(player.mo, sfx_s3k8a, 128)
			
			//Set the position
			local newzpos
			if player.mo.flags2&MF2_OBJECTFLIP
				newzpos = player.mo.z-(2*player.mo.scale)-closestmo.height
			else
				newzpos = player.mo.z+player.mo.height+(2*player.mo.scale)
			end
			
			// Now draw the line to the object from the tracer
			local numLineMobjs = min(max(R_PointToDist2(player.mo.x, player.mo.y, player.mo.x, closestmo.y)/(player.mo.scale*48), 16), 64)
	
			// Get distance for each step
			local distX = (closestmo.x - player.mo.x) / numLineMobjs
			local distY = (closestmo.y - player.mo.y) / numLineMobjs
			local distZ = (closestmo.z - newzpos) / numLineMobjs
			
			local i = 0 while (i <= numLineMobjs)
				local part = P_SpawnGhostMobj(closestmo)
				P_TeleportMove(part, player.mo.x + distX*i, player.mo.y + distY*i, newzpos + distZ*i)
				part.fuse = (numLineMobjs-i)/3+1
				if i < numLineMobjs/2
					part.angle = player.drawangle
				end
				part.momx = player.mo.momx
				part.momy = player.mo.momy
				part.momz = player.mo.momz
				i = $+1
			end
			
			player.milnecarry = closestmo
		
		//Crystal Toss and Crystal Lance
		//No doing it when you can use a shield ability!
		elseif ((player.powers[pw_shield] & SH_NOSTACK) == SH_NONE
		or (player.powers[pw_shield] & SH_NOSTACK) == SH_PITY
		or (player.powers[pw_shield] & SH_NOSTACK) == SH_PINK
		or P_IsObjectOnGround(player.mo) or not (player.pflags&PF_JUMPED)
		or player.pflags&PF_THOKKED or player.pflags&PF_SHIELDABILITY)
			//Crystal Lance
			if player.weapondelay > TICRATE/4 and
			(player.mo.state == S_PLAY_FIRE or S_PLAY_FIRE_FINISH)
			and not player.crystallance and not player.powers[pw_carry]
				startcrystallance(player)
			
			//Crystal Toss
			elseif not player.weapondelay
				S_StartSound(player.mo, sfx_crythr)
			
				local i = 0 while i < 3
					local crystal = P_SPMAngle(player.mo, MT_THROWNCRYSTAL,
					player.mo.angle+(ANGLE_11hh/2)-((ANGLE_11hh/2)*i), 0, MF2_BOSSNOTRAP)
					if crystal and crystal.valid
						crystal.name = "crystal shards"
						if CBW_Battle and CBW_Battle.BattleGametype()
						and not (gametyperules&GTR_FRIENDLY)
							crystal.momx = $/2
							crystal.momy = $/2
						end
					end
					i = $+1
				end
			
				local thok = P_SpawnMobjFromMobj(player.mo,
				P_ReturnThrustX(nil,player.mo.angle,FixedDiv(player.mo.radius,player.mo.scale)),
				P_ReturnThrustY(nil,player.mo.angle,FixedDiv(player.mo.radius,player.mo.scale)),
				FixedDiv(player.mo.height/3,player.mo.scale),MT_THOK)
				local ghost = P_SpawnGhostMobj(thok)
				P_KillMobj(thok)
				ghost.color = SKINCOLOR_SUPERPURPLE2
				ghost.scale = $/8
				ghost.destscale = $*8
				ghost.scalespeed = $*2
				ghost.momx = player.mo.momx*2/3
				ghost.momy = player.mo.momy*2/3
				ghost.momz = player.mo.momz
				
				player.mo.state = S_PLAY_FIRE
				player.mo.tics = 3
				player.mo.momx = $/2
				player.mo.momy = $/2
				player.drawangle = player.mo.angle
				player.pflags = $&~PF_JUMPED&~PF_SPINNING&~PF_STARTDASH
				player.weapondelay = TICRATE/2
			end
		end
	end
end)

//Extra boost from steam
addHook("MobjMoveCollide", function(tmthing, thing)
	if tmthing and tmthing.valid and tmthing.player and tmthing.skin == "milne"
	and thing and thing.valid and thing.type == MT_STEAM
	and (thing.z - thing.scale <= tmthing.z + tmthing.height
	and thing.z + thing.height + thing.scale >= tmthing.z)
		tmthing.milnesteam = true
	end
end, MT_PLAYER)

//Extra boost from damaging enemies
addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if target and target.valid and (target.flags&MF_ENEMY or target.flags&MF_BOSS
	or target.flags&MF_MONITOR) and inflictor and inflictor.valid
	and inflictor.player and inflictor.skin == "milne" and damagetype != DMG_NUKE
		inflictor.momz = $*GRAVITYMUL/GRAVITYDIV
	end
end)

//Extra boost from destroying monitors
addHook("MobjDamage", function(target, inflictor)
	if target and  target.valid and target.flags&MF_MONITOR and inflictor
	and inflictor.valid and inflictor.player and inflictor.skin == "milne"
		inflictor.momz = $*GRAVITYMUL/GRAVITYDIV
	end
end)

//Battle Mod Support
local ScriptLoaded = false
addHook("ThinkFrame", function()
	if not(CBW_Battle) or ScriptLoaded then return end
	ScriptLoaded = true
	
	local function GarbagePriority3(player)
		if player.mo.state == S_PLAY_SPINDASH
			CBW_Battle.SetPriority(player,1,1,nil,1,1,"twister thok attack")
		end
	end
	
	CBW_Battle.SkinVars["milne"] = {
		weight = 115,
		func_priority_ext = GarbagePriority3
	}
end)